// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/Scene.hpp"
#include "display/TextureRenderTarget.hpp"
#include "scene/components/display/Camera.hpp"

namespace Dawn {
  class SubSceneCameraAlign : public SceneItemComponent {
    protected:
      TextureRenderTarget *renderTarget = nullptr;
      Camera *camera = nullptr;

      void onRenderTargetResize(RenderTarget *target, float_t w, float_t h);

      void realign();

    public:

      SubSceneCameraAlign(SceneItem *item);

      void setRenderTarget(TextureRenderTarget *renderTarget);
      void setCamera(Camera *camera);

      void onStart() override;

      ~SubSceneCameraAlign();
  };
}